package dec15;
$Ndig = 13;  #change this for the precision
$eps = 10**(-$Ndig);
sub geteps { #return the current granularity
  return $eps;
}
sub dump15s { #return a $Ndig-digit value string with trailing blank
  my($t);
  $t = shift;
  if ($t < 1.0) {
    $t = int((($t/$eps)+.5))*$eps;
  }
  $t = sprintf "%.*e ", $Ndig-1,$t; 
  return $t;
}
sub epsplace { #return a value that can be used with arg as eps
  my($t,$i,$e,$val);
  $t = shift; 
  $t = dump15s(abs($t));
  $i = index($t,"e");
  $e = substr($t,$i+1); #exponent
  $e = $e + 1 -$Ndig;
  $val = "1.0e".$e;
  return $val;
}
return 1;
